//def_MODNUMNSP_path()
//Input : nothing
//Output : tt MODNUMNSP path (ex:/home/alan/modnum_3)
function tt=def_MODNUMNSP_path()
  tt=get_current_exec_dir()
  if tt=='' then
    tt=getcwd();
  else
    end_char=part(tt,length(tt));
    if end_char=='/'|end_char=='\' then
      tt=part(tt,1:length(tt)-1);
    end
  end
endfunction

//define MODNUM path
MODNUMNSP = def_MODNUMNSP_path();

//Version checking
printf("... Version checking ...\n");

//Display Os version
//???
printf("OS is : %s-%s\n","?","?");

//Display Modnum Version
exec(MODNUMNSP+'/macros/build_util/get_modnumnsp_version.sci');
ver=get_modnumnsp_version();
printf("Version of Modnum is : %s\n",ver);
clear ver;

//Display Nsp Version
//???
printf("Version of Nsp is : %s\n","?");

//save cur dir
cur_rep = getcwd();

//ulink previoulsy loaded shared library
//scicoslibs
if exists('Id_libmodnum_comm_c') then
  ulink(Id_libmodnum_comm_c);
  clear Id_libmodnum_comm_c;
end
if exists('Id_libmodnum_filt_c') then
  ulink(Id_libmodnum_filt_c);
  clear Id_libmodnum_filt_c;
end
if exists('Id_libmodnum_int_c') then
  ulink(Id_libmodnum_int_c);
  clear Id_libmodnum_int_c;
end
if exists('Id_libmodnum_old_c') then
  ulink(Id_libmodnum_old_c);
  clear Id_libmodnum_old_c;
end
if exists('Id_libmodnum_oth_c') then
  ulink(Id_libmodnum_oth_c);
  clear Id_libmodnum_oth_c;
end
if exists('Id_libmodnum_pll_c') then
  ulink(Id_libmodnum_pll_c);
  clear Id_libmodnum_pll_c;
end
if exists('Id_libmodnum_signal_c') then
  ulink(Id_libmodnum_signal_c);
  clear Id_libmodnum_signal_c;
end
if exists('Id_libmodnum_sink_c') then
  ulink(Id_libmodnum_sink_c);
  clear Id_libmodnum_sink_c;
end
if exists('Id_libmodnum_tool_c') then
  ulink(Id_libmodnum_tool_c);
  clear Id_libmodnum_tool_c;
end
if exists('Id_libmodnum_src_c') then
  ulink(Id_libmodnum_src_c);
  clear Id_libmodnum_src_c;
end
if exists('Id_libmodnum_nlin_c') then
  ulink(Id_libmodnum_nlin_c);
  clear Id_libmodnum_nlin_c;
end

if exists('Id_libintmodnumlib') then //gateway
  ulink(Id_libintmodnumlib);
  clear Id_libintmodnumlib;
end
if exists('Id_libmodnumlib') then //library
  ulink(Id_libmodnumlib);
  clear Id_libmodnumlib;
end

//Build and load modnum_lib routines
printf("Building modnum_lib C routines...");
path='/../../src';
fils = glob(MODNUMNSP+path+'/*.c');
lisf = [];
for i=1:size(fils,1)
  lisf=[lisf;file("rootname",file("tail",fils(i)))];
end
libnam="modnum_lib";
cflag="-DWITH_FFTW=1 -DWITH_SCIFFT=0";

//set LDFLAGS
if %win32 then
  ldflag='""'+file('join',[getenv('NSP')+"/bin/";'libfftw3-3.lib'])+'"" ';
else
  ldflag="";
end

chdir(MODNUMNSP+path);
[libn,ok]=ilib_for_link(lisf,lisf+".o",[],"c",makename="Makelib",loadername="loader.sce",libname=libnam,cflags=cflag,ldflags=ldflag,verbose=%f);

//build successful
if ok then
  printf("Done\n");
  //link shared lib of modnum_lib routines
  printf(" Linking modnum_lib shared library...");
  Id_libmodnumlib=link('libmodnum_lib'+%shext);
  printf("Done\n");

  //Build and load scilab interface of modnum_lib routines
  printf("Building Nsp interfaces...");
  path='/gateway';
  fils = glob(MODNUMNSP+path+'/*.c');
  lisf = [];
  for i=1:size(fils,1)
    lisf=[lisf;file("rootname",file("tail",fils(i)))];
  end
  libnam="intmodnum_lib";

  //set LDFLAGS
  if %win32 then
    ldflag='""'+file('join',[MODNUMNSP;'/../../src';'libmodnum_lib.lib'])+'""';
  else
    ldflag="";
  end

  //set CFLAGS
  cflag="-I"""+MODNUMNSP+"/../../src"" -c";

  chdir(MODNUMNSP+path);
  [libn,ok]=ilib_for_link(lisf,lisf+".o",[],"c",makename="Makelib",loadername="loader.sce",libname=libnam,cflags=cflag,ldflags=ldflag,verbose=%f);
  //build successful
  if ok then
    printf("Done\n");

    printf(" Linking Nsp interfaces...");
    Id_libintmodnumlib=link('libintmodnum_lib'+%shext);
    addinter(Id_libintmodnumlib,'intmodnum_lib');
    printf("Done\n");

    chdir(MODNUMNSP);
    printf("Registering documentation...");
    help(MODNUMNSP+'/help/eng/htm/modnumnsp.4dx');
    printf("Done\n");

    printf("Generating a loader.sce file...");
    path="/macros/build_util";
    exec(MODNUMNSP+path+'/generate_loader.sce');
    printf("Done\n");

  else
    printf("Build of modnum_lib nsp interface failed.\n");
    clear MODNUMNSP; clear get_modnumnsp_version;
  end

else
  printf("Build of modnum_lib shared lib failed.\n");
  clear MODNUMNSP; clear get_modnumnsp_version;
end

chdir(cur_rep);

clear i;
clear def_MODNUMNSP_path;
clear libn;
clear path;
clear fils;
clear lisf;
clear cur_rep;
clear libnam;
clear cflag;
clear ldflag;
clear ok;
